using System;

using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Microsoft.Win32;

namespace CheckKeyboard
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Значение подраздела
        const string subkeyValue = @"Software\Microsoft\Shell";
        // Значение ключа
        const string keyboardKey = "HasKeyboard";

        // Имеется ли клавиатура
        bool IsKeyboardPresent()
        {
            bool hasKeyboard = false;
            RegistryKey shellSubKey = null;

            try
            {           
                // Открываем нужный подраздел
                shellSubKey = Registry.CurrentUser.OpenSubKey(subkeyValue);
                if (shellSubKey != null)
                {
                    // Получим значение парааметра HasKeyboard
                    int keyboardValue = (int)shellSubKey.GetValue(keyboardKey,0);
                    hasKeyboard = keyboardValue == 1;
                }
            }
            finally
            {
                if (shellSubKey != null)
                    shellSubKey.Close();
            }

            return hasKeyboard;
        }

        private void menuCheck_Click(object sender, EventArgs e)
        {
            lblCheckKeyboard.Text = 
                IsKeyboardPresent() ? "Клавиатура имеется" : "Клавиатуры нет";
        }
    }
}